##############################
#
# Homework 4, Problem 3
#
# Write a function that draws arbitrary lines
# in a text "framebuffer" consisting of 32 lines of
# 63 characters (plus a newline).
#
# In C, its declaration would be
#
#   void line(int x0, int y0, int x1, int y1);
#
# Your implementaiton must adhere to the MIPS calling conventions
# and use this template.  Modify the file only where indicated.
#
# Base your code on the C implementation in star.c.
#
# You do not have to follow it exactly.  E.g., I did not
# write an assembly subroutine for plot().
#
# Consider using the MIPS assembler pseudoinstruction
#	
#   abs rd, rs
#
# which places the absolute value of the two's-complement
# contents of rs in rd.
#
# The byte address of a character in the framebuffer is
#
#    fb + 64 * y + x
#
##############################
	# x0 and y0, the starting coordinates, are in $a0 and $a1
	# x1 and y1, the ending coordinates, are in $a2 and $a3

line:

	####################
	#
	# Your solution goes here
	#
	###################

# Draw an image that looks like
#
#               *              
#              * *               
#             *   *              
#             *   *            
#  ***************************  
#    **     *       *      *    
#      **   *       *   **      
#         **         **         
#          * **    ** *         
#         *   *****   *         
#         *   *   *   *        
#        *  *        * *         
#        *             *       
#
# See "star-output.txt" for the exact output

main:
	li $a0, 31
	li $a1, 1
	li $a2, 47
	li $a3, 28
	jal line
	
	li $a0, 57
	li $a1, 11
	li $a2, 14
	li $a3, 28
	jal line

	li $a0, 47
	li $a1, 28
	li $a2, 4
	li $a3, 11
	jal line

	li $a0, 14
	li $a1, 28
	li $a2, 30
	li $a3, 1
	jal line

	li $a0, 4
	li $a1, 11
	li $a2, 57
	li $a3, 11
	jal line

	li $v0, 4
	la $a0, fb
	syscall    # Print the framebuffer
	
	li $v0, 10 # exit
	syscall

	
	.data
	
fb:	# Each line is exactly 64 characters: 63 spaces plus a newline
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .ascii "                                                               \n"
  .asciiz "                                                               \n"
